 --
 -- Lua for grimme tectron in LS 2011
 -- @author  usxi7sd
 -- @date  10/2012
 --
   
tectronernte = {};

function tectronernte.prerequisitesPresent(specializations)
    return true;
end;

function tectronernte:load(xmlFile)	
		self.threshingUVScrollParts = {};
        local i = 0;
        while true do
            local key = string.format("vehicle.threshingUVScrollParts.threshingUVScrollPart(%d)", i);
            if not hasXMLProperty(xmlFile, key) then
                break;
            end;
            local node = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."#index"));
            local speed = Utils.getVectorNFromString(getXMLString(xmlFile, key.."#speed"), 2);
            if node ~= nil and speed then
                table.insert(self.threshingUVScrollParts, {node=node, speed=speed});
            end;
           i = i +1;
       end;
	self.visibility1 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.visibility1#index"));
	setVisibility(self.visibility1, false);	
	self.visibility2 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.visibility2#index"));
	setVisibility(self.visibility2, false);
	self.visibility4 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.visibility4#index"));
	setVisibility(self.visibility4, false);
	self.visibility5 = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.visibility5#index"));
	setVisibility(self.visibility5, false);
end;

function tectronernte:delete()
end;
function tectronernte:readStream(streamId, connection)
end;
function tectronernte:writeStream(streamId, connection)
end;
function tectronernte:mouseEvent(posX, posY, isDown, isUp, button)
end;
function tectronernte:keyEvent(unicode, sym, modifier, isDown)
end;

function tectronernte:update(dt)
		if self.isThreshing then
				for _, part in pairs(self.threshingUVScrollParts) do
					setShaderParameter(part.node, "uvScrollSpeed", part.speed[1], part.speed[2], 0, 0, false);
				end;
				else
				for _, part in pairs(self.threshingUVScrollParts) do
					setShaderParameter(part.node, "uvScrollSpeed", 0, 0, 0, 0, false);
				end;		
		end;
		----------------------------------------------------------------------------------
		if self.chopperPSenabled then		                                                            
			setVisibility(self.visibility1, true);   -- frderplane
			setVisibility(self.visibility2, true);  -- Texture middleTransporter
			setVisibility(self.visibility4, true);  -- Texture middleTransporter abw1
			setVisibility(self.visibility5, true);  -- Texture middleTransporter abw2
		else			
			setVisibility(self.visibility1, false);  -- frderplane
			setVisibility(self.visibility2, false);  -- Texture middleTransporter
			setVisibility(self.visibility4, false);  -- Texture middleTransporter abw1
			setVisibility(self.visibility5, false);  -- Texture middleTransporter abw2
		end;
end;

function tectronernte:updateTick(dt)	
end;
function tectronernte:draw()
end;

function tectronernte:onStartReel()
		self.reelStarted = true;   
		for _, part in pairs(self.threshingUVScrollParts) do
           setShaderParameter(part.node, "uvScrollSpeed", part.speed[1], part.speed[2], 0, 0, false);
		end;		
end;

function tectronernte:onStopReel()
		self.reelStarted = false;
		Utils.setEmittingState(self.threshingParticleSystems, false);
		self.speedViolationTimer = self.speedViolationMaxTime;   
		for _, part in pairs(self.threshingUVScrollParts) do
			setShaderParameter(part.node, "uvScrollSpeed", 0, 0, 0, 0, false);
		end;
 end;

function tectronernte:onDeactivate()
end;
function tectronernte:onStartTip(currentTipTrigger, noEventSend)  
end;
function tectronernte:onEndTip(noEventSend) 
end;
function tectronernte:setIsTurnedOn(turnedOn, noEventSend)
end;